/* testing BSF4Rexx Rexx functions, ---rgf, 2003-01-27

   start either via Rexx or Java, i.e. enter "rexx TestBSF4Rexx.rex" or "rexxj TestBSF4Rexx.rex"

*/
parse version version
say "Rexx-version: ["version"]"
parse source source
say "Rexx-source : ["source"]"
say

func="BsfLoadFuncs"
dll ="BSF4Rexx"
say func "loaded?" RxFuncQuery(func)
say copies("-", 70)

if RxFuncQuery("BSF")=1 then   /* load/register BSF functions */
do
   say "loading the BSF loader function..."
   call rxFuncAdd func, dll, func
   say copies("-", 70)
   say "func="func "now executing it!"
   /* call (func) -- ORexx functionality */
   call BsfLoadFuncs
   say copies("-", 70)

   say func "now loaded?" RxFuncQuery(func)
   say copies("-", 70)

/* Regina-error as if "BSFINVOKEDBY" was passed to cmd.exe!
call BSFINVOKEDBY
say result
*/
   say "loading Java, initializing the Java side of BSF4Rexx ..."
   say "===> BsfLoadJava():" BSFLoadJava()   /* Regina: "BSFLOADJAVA" is addressed with cmd.exe !!! */
   say copies("-", 70)
end

state=BsfInvokedBy()    /* get invocation type  */
if      state=0 then say "invocation type: no JVM present, we are in **troubles** !"
else if state=1 then say "invocation type: via Java."
else                 say "invocation type: via Rexx (Rexx loaded Java)."
say copies("-", 70)

say "BSF4Rexx-version:" BsfVersion()
say copies("-", 70)

say "Query ALL BSF4Rexx-functions, using the default name of the stem as"
say "set by the function, i.e. 'BsfQueryAllFunctions.':"
call BsfQueryAllFunctions   /* this will return a stem-array of the available BSF4Rexx functions */
do i=1 to BSFQueryALLFUNCTIONS.0
   say "BSF4Rexx-function #" i":" BsfQueryAllFunctions.i
end
say copies("-", 70)

say "Query REGISTERED BSF4Rexx-functions, using the default name of the stem as"
say "set by the function, i.e. 'BsfQueryRegisteredFunctions.':"
call BsfQueryRegisteredFunctions    /* this will return a stem-array of the available BSF4Rexx functions */
do i=1 to BsfQueryRegisteredFunctions.0
   say "BSF4Rexx-function #" i":" BsfQueryRegisteredFunctions.i
end
say copies("-", 70)

say "Query REGISTERED BSF4Rexx-functions, using stem name 'oHo.' as an argument:"
call BsfQueryRegisteredFunctions "oHo."  /* this will return a stem-array of the available BSF4Rexx functions */
do i=1 to oho.0
   say "BSF4Rexx-function #" i":" oho.i
end
say copies("-", 70)


say "sleeping a second via Java..."
call time "reset"
call bsf "sleep", "1.0"
say "   ... elapsed time:" time("e")
say

if BsfInvokedBy()=2 then   /* was Java loaded by Rexx, if so, play with the other functions */
do
   say copies("=", 70)
   say "Java was loaded by Rexx, now playing with the other BSF...() functions ..."
   say
   say "===> BsfUnloadJava():" BsfUnloadJava()
   say copies("-", 70)

   say "===> BsfLoadJava():" BSFLoadJava()
   say copies("-", 70)

   say "sleeping a second via Java..."
   call time "reset"
   call bsf "sleep", "1.0"
   say "   ... elapsed time:" time("e")
   say copies("-", 70)

   say "===> BsfDropFuncs():" BsfDropFuncs() "(also drops access to the JVM)"
   say copies("-", 70)

   say func "loaded?" RxFuncQuery(func)
   say copies("-", 70)

   say "now registering 'BsfLoadFuncs()' ..."
   call rxFuncAdd func, dll, func
               /* Regina: "Incorrect call to routine" ?  */
   say "===> BsfLoadFuncs():" BsfLoadFuncs()
   say copies("-", 70)

   say "Query REGISTERED BSF4Rexx-functions, using stem name 'oHo.' as an argument:"
   call BsfQueryRegisteredFunctions "oHo."  /* this will return a stem-array of the available BSF4Rexx functions */
   do i=1 to oho.0
      say "BSF4Rexx-function #" i":" oho.i
   end
   say copies("-", 70)

   say "O.K., JVM should not be accessible, expecting '0':"
   say "===> BsfInvokedBy():" BsfInvokedBy()
   say copies("-", 70)

   say "===> BsfLoadJava():" BSFLoadJava()
   say copies("-", 70)

   say "O.K., now JVM accessible again:"
   say "===> BsfInvokedBy():" BsfInvokedBy()
   say copies("-", 70)

   say "sleeping a second via Java..."
   call time "reset"
   call bsf "sleep", "1.0"
   say "   ... elapsed time:" time("e")
   say copies("-", 70)

   say "===> BsfUnloadJava():" BsfUnloadJava()
   say copies("-", 70)

   say "===> BsfDropFuncs():" BsfDropFuncs() "(also drops access to the JVM)"
   say copies("-", 70)
end
say center(" over ", 70, "-")
